#define NUM_TAPS 12
uniform float max_coc;
uniform vec2 tap_array[NUM_TAPS];
uniform samplerRect cmap;
uniform samplerRect dbmap;

void main(void)
{
    vec4   clr;          // sum colors into this, and get final color value
    float  total_weight; // aggregate weights of each sampling
    vec2   center_db;    // our frags linear depth and blur coefficient
    float  coc;          // CoC of this pixel
    int    i; 

    clr          = textureRect(cmap,gl_TexCoord[0].st);
    total_weight = 1.0;
    center_db    = vec2( textureRect(dbmap,gl_TexCoord[0].st) );
    coc          = center_db.y * max_coc;

    for( i = 0; i < NUM_TAPS; i++)
    {
        vec2  tap_st  = gl_TexCoord[0].st + (tap_array[i] * coc);
        vec4  tap_clr = textureRect(cmap,tap_st);
        vec2  tap_db  = vec2( textureRect(dbmap,tap_st) );
        float tap_weight = (tap_db.x > center_db.x) ? 1.0 : tap_db.y;

        clr += tap_clr * tap_weight;
        total_weight += tap_weight;
    }

    gl_FragColor = clr / total_weight;
}
