uniform float focal_dist;
uniform float focal_range;
uniform float scene_range;
uniform sampler2D cmap;

varying vec4  ed;
varying vec3  ld;
varying vec3  norm;
varying vec4  diffuse;
varying vec4  ambient;

void main(void)
{
    vec3 n = normalize(norm);
    vec4 lc = ambient;
    float ndotl = max( dot(n,ld), 0.0);
    if( ndotl > 0.0 )
    {
        lc += diffuse * ndotl;
    }

    vec4 tclr = texture2D(cmap,gl_TexCoord[0].st);

    float deltad = abs( ed.z - focal_dist) / focal_range;
    float blur = clamp( deltad, 0.0, 1.0);

    gl_FragData[0] = tclr.rgba * lc.rgba;
    gl_FragData[1] = vec4( ed.z / scene_range, blur, blur, 1.0);
}
